| Exiv2

Loading...
Searching...
No Matches
Classes | Public Types | List of all members
Exiv2::DateValue Class Reference

Value for simple ISO 8601 dates More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::DateValue:
[legend]

## Classes
struct | Date
| Simple Date helper structure. More...

## Public Types
using | UniquePtr = std::unique_ptr<DateValue>
| Shortcut for a DateValue auto pointer.
Public Types inherited from Exiv2::Value
using | UniquePtr = std::unique_ptr<Value>
| Shortcut for a Value auto pointer.

## Public Member Functions
Creators
| DateValue ()
| Default constructor.
| DateValue (int32_t year, int32_t month, int32_t day)
| Constructor.
Manipulators
int | read (const byte *buf, size_t len, ByteOrder byteOrder=invalidByteOrder) override
int | read (const std::string &buf) override
| Set the value to that of the string buf.
void | setDate (const Date &src)
| Set the date.
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()=default
| Virtual destructor.
virtual int | setDataArea (const byte *buf, size_t len)
| Set the data area, if the value has one by copying (cloning) the buffer pointed to by buf.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
UniquePtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
virtual std::string | toString (size_t n) const
| Return the n-th component of the value as a string. The default implementation returns toString(). The behaviour of this method may be undefined if there is no n-th component.
virtual size_t | sizeDataArea () const
| Return the size of the data area, 0 if there is none.
virtual DataBuf | dataArea () const
| Return a copy of the data area if the value has one. The caller owns this copy and DataBuf ensures that it will be deleted.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors
UniquePtr | clone () const
size_t | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const override
| Write value to a character data buffer.
virtual const Date & | getDate () const
| Return date struct containing date information.
size_t | count () const override
| Return the number of components of the value.
size_t | size () const override
| Return the size of the value in bytes.
std::ostream & | write (std::ostream &os) const override
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
int64_t | toInt64 (size_t n=0) const override
| Return the value as a UNIX calendar time converted to int64_t.
uint32_t | toUint32 (size_t n=0) const override
| Return the value as a UNIX calendar time converted to uint32_t.
float | toFloat (size_t n=0) const override
| Return the value as a UNIX calendar time converted to float.
Rational | toRational (size_t n=0) const override
| Return the value as a UNIX calendar time converted to Rational.

## Additional Inherited Members
static UniquePtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
| Value (const Value &)=default
Value & | operator= (const Value &)=default
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
bool | ok_ {true}
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

Value for simple ISO 8601 dates

This class is limited to parsing simple date strings in the ISO 8601 format CCYYMMDD (century, year, month, day).

## Member Function Documentation

## ◆ copy()

size_t Exiv2::DateValue::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder = invalidByteOrder ) const
| override virtual

Write value to a character data buffer.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Note
  The byte order is required by the interface but not used by this method, so just use the default.

Parameters

  buf | Data buffer to write to.
  byteOrder | Byte order. Not used.

Returns
  Number of characters written.

Implements Exiv2::Value.

## ◆ count()

size_t Exiv2::DateValue::count | ( |  | ) | const
| override virtual

Return the number of components of the value.

Implements Exiv2::Value.

References size().

Referenced by read().

## ◆ read() [1/2]

int Exiv2::DateValue::read | ( | const byte * | buf,
|  | size_t | len,
|  | ByteOrder | byteOrder = invalidByteOrder )
| override virtual

Returns
  0 if successful
  1 in case of an unsupported date format

Implements Exiv2::Value.

References read().

Referenced by read().

## ◆ read() [2/2]

int Exiv2::DateValue::read | ( | const std::string & | buf | ) |
| override virtual

Set the value to that of the string buf.

Parameters

  buf | String containing the date

Returns
  0 if successful
  1 in case of an unsupported date format

Implements Exiv2::Value.

References count(), and EXV_WARNING.

## ◆ size()

size_t Exiv2::DateValue::size | ( |  | ) | const
| override virtual

Return the size of the value in bytes.

Implements Exiv2::Value.

Referenced by count().

## ◆ toFloat()

float Exiv2::DateValue::toFloat | ( | size_t | n = 0 | ) | const
| override virtual

Return the value as a UNIX calendar time converted to float.

Implements Exiv2::Value.

References toInt64().

## ◆ toInt64()

int64_t Exiv2::DateValue::toInt64 | ( | size_t | n = 0 | ) | const
| override virtual

Return the value as a UNIX calendar time converted to int64_t.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

Referenced by toFloat(), toRational(), and toUint32().

## ◆ toRational()

Rational Exiv2::DateValue::toRational | ( | size_t | n = 0 | ) | const
| override virtual

Return the value as a UNIX calendar time converted to Rational.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and toInt64().

## ◆ toUint32()

uint32_t Exiv2::DateValue::toUint32 | ( | size_t | n = 0 | ) | const
| override virtual

Return the value as a UNIX calendar time converted to uint32_t.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and toInt64().

## ◆ write()

std::ostream & Exiv2::DateValue::write | ( | std::ostream & | os | ) | const
| override virtual

Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

Implements Exiv2::Value.

The documentation for this class was generated from the following files:

- value.hpp
- value.cpp